#include "binload.hpp"

#include <stdio.h>

using namespace yyybinbuff;

void loadbinbuff(yyybinbuff::binbuff &b, const string &filename)
{
  FILE *f = fopen(filename.c_str(),"rb");
  if (!f) throw error_loadsave_binbuff();
  try {
    binbuff::index todo=1024*10, pos=0, result;
  
    do{
      b.resize(pos+todo);
      result = fread(&b[pos],1,todo,f);
      if (result>0) {
	pos+=result;
      } else if (result==0) {
	if (ferror(f)) throw error_loadsave_binbuff();
      } else {
	throw error_loadsave_binbuff();
      };
    } while (result!=0);
    b.resize(pos);

    fclose(f);
  } catch (...) {
    if (f) fclose(f);
    throw;
  };
};

void savebinbuff(const yyybinbuff::binbuff &b, const string &filename)
{
  FILE *f = fopen(filename.c_str(),"wb");
  if (!f) throw error_loadsave_binbuff();
  try {
    binbuff::index todo=1024*10, pos=0, result, now;

    while (pos<b.size()) {
      now = (b.size()-pos>todo) ? todo : b.size()-pos;
      result = fwrite(&b[pos],1,now,f);
      if (result == now) {
	pos+=result;
      } else {
	throw error_loadsave_binbuff();
      };
    };
  
    fclose(f);
  } catch (...) {
    if (f) fclose(f);
    throw;
  };
};
