#include "rgbamap.hpp"
#include "yyysmartptr.hpp"
#include "yyygtkscheduler.hpp"
#include "yyynetwork.hpp"
#include "yyypostman.hpp"
#include "memchk.hpp"
#include "sendsmartptr.hpp"
#include "binload.hpp"
#include "sendstring.hpp"
#include "sendbinbuff.hpp"
#include "ident.hpp"
#include "sprite.hpp"
#include "visor.hpp"

#include <iostream>
#include <strstream>
#include <algorithm>
#include <gtk--/window.h>
#include <gtk--/main.h>
#include <gtk--/pixmap.h>
#include <gtk--/button.h>
#include <gtk--/style.h>
#include <gtk--/drawingarea.h>
#include <gtk--/box.h>
#include <gtk--/paned.h>
#include <gtk--/fileselection.h>
#include <gtk--/menu.h>
#include <gtk--/menubar.h>
#include <gtk--/eventbox.h>
#include <gtk--/clist.h>

#include <stdio.h>

using namespace SigC;
using namespace Gtk;
using namespace yyysmartptr;
using namespace yyygtkscheduler;
using namespace yyybinbuff;
using namespace yyynetwork;
using namespace yyypostman;

typedef connection<scheduler,binbuff> con_t;
typedef smartptr<con_t> sptr_con_t;
typedef client<scheduler, binbuff> client_t;
typedef postman<uint8,con_t> postman_t;
typedef smartptr<postman_t> sptr_postman_t;
typedef smartptr<binbuff> sptr_binbuff;

#include <gtk/gtk.h>
void error_dialog(char *Error)
{
  /*
    Standard, run-of-the-mill message box
    shamelessly stolen from the www.gphoto.org project :)
  */
  
  GtkWidget *dialog, *label, *button;
  
  dialog = gtk_dialog_new();
  GTK_WINDOW(dialog)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_title(GTK_WINDOW(dialog), "gPhoto Message");
  gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
  gtk_container_border_width(GTK_CONTAINER(dialog), 5);
  label = gtk_label_new(Error);
  button = gtk_button_new_with_label("OK");
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
                            GTK_SIGNAL_FUNC(gtk_widget_destroy),
                            GTK_OBJECT(dialog));
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox),
		     label, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		     button, TRUE, TRUE, 0);
  gtk_widget_show(label);
  gtk_widget_show(button);
  gtk_widget_show(dialog);
  gtk_widget_grab_default (button);
};

void puttempmatpart (int32 dx, int32 dy, int32 px, int32 py, int32 psx, int32 psy,
		     const tempmatrix<rgba> &src, tempmatrix<rgba> &dst, bool ignore_transparency)
{
  int32 overhang;

  // top clipping the part
  if (py<0) {
    psy+=py;
    dy-=py;
    py=0;
  };

  // left clipping the part
  if (px<0) {
    psx+=px;
    dx-=px;
    px=0;
  };

  // bottom clipping the part
  overhang=py+psy-src.ysize();
  if (overhang>0) psy-=overhang;

  // right clipping the part
  overhang=px+psx-src.xsize();
  if (overhang>0) psx-=overhang;

  int32 anzlines=psy;
  int32 anzcount=psx;
  const rgba *sourceptr=src.getrawdatapointer() + py*src.xsize()+px;
  rgba *destptr=dst.getrawdatapointer() + dy*dst.xsize()+dx;
  int32 sourceadder=src.xsize()-anzcount;
  int32 destadder=dst.xsize()-anzcount;

  // top clipping
  if (dy<0) {
    anzlines+=dy;
    sourceptr-=src.xsize()*dy;
    destptr-=dst.xsize()*dy;
    // dy=0; but not used anymore
  };

  // left clipping
  if (dx<0) {
    anzcount+=dx;
    sourceptr-=dx;
    destptr-=dx;
    sourceadder-=dx;
    destadder-=dx;
    // dx=0; but not used anymore.
  };

  // bottom clipping
  overhang=dy+psy-dst.ysize();
  if (overhang>0) {
    anzlines-=overhang;
  };

  // right clipping
  overhang=dx+psx-dst.xsize();
  if (overhang>0) {
    anzcount-=overhang;
    sourceadder+=overhang;
    destadder+=overhang;
  };

  if ((anzcount<=0) || (anzlines<=0)) return;
  
  if (ignore_transparency) {
    sourceadder += anzcount;
    destadder += anzcount;
    for (int32 lines = 0; lines < anzlines; lines++) {
      memcpy(destptr,sourceptr,anzcount*4);
      sourceptr += sourceadder;
      destptr += destadder;
    };
  }else{
    for (int32 lines = 0; lines < anzlines; lines++) {
      const rgba *sourceptrend = sourceptr + anzcount;
      while (sourceptr < sourceptrend) {
        const rgba &col = *(sourceptr++);
	(*destptr)[0]=(col[3]*col[0]+(255-col[3])*(*destptr)[0])/255;
	(*destptr)[1]=(col[3]*col[1]+(255-col[3])*(*destptr)[1])/255;
	(*destptr)[2]=(col[3]*col[2]+(255-col[3])*(*destptr)[2])/255;
	(*destptr)[3]=col[3];
	//        if (col[3]!=0) *destptr=const_cast<rgba&>(col);
        destptr++;
      };
      sourceptr += sourceadder;
      destptr += destadder;
    };
  };
};

void puttempmat (int32 dx, int32 dy,
		 const tempmatrix<rgba> &src, tempmatrix<rgba> &dst, bool ignore_transparency)
{
  puttempmatpart(dx,dy,0,0,src.xsize(),src.ysize(),src,dst,ignore_transparency);
};


void drawsprite (const DrawingArea &win, gint px, gint py, const tempmatrix<rgba> &mat)
{
  typedef uint8 rgb[3];
  tempmatrix<rgb> rgbmat(mat.xsize(), mat.ysize());
  const rgba *const matp = mat.getrawdatapointer();
  rgb *const rgbmatp = rgbmat.getrawdatapointer();
  int count=mat.getcount();
  for (int i=0;i<count;++i) {
    rgbmatp[i][0]=matp[i][0];
    rgbmatp[i][1]=matp[i][1];
    rgbmatp[i][2]=matp[i][2];
  };

  gdk_draw_rgb_image(win.get_window(), win.get_style()->get_white_gc(),
		     px,py,
		     rgbmat.xsize(),rgbmat.ysize(),
		     GDK_RGB_DITHER_NONE,(uint8*)rgbmat.getrawdatapointer(),rgbmat.xsize()*3);
};


class basewin;


class dicewidget : public DrawingArea
{
public:
  dicewidget (basewin *const bw_);

  virtual gint configure_event_impl (GdkEventConfigure *);
  virtual gint expose_event_impl (GdkEventExpose *event);
  virtual gint button_press_event_impl (GdkEventButton *event);
  virtual gint button_release_event_impl (GdkEventButton *event);
  virtual gint motion_notify_event_impl (GdkEventMotion *event);
  basewin *const bw;
  ident_t selid;
  int32 selxsub, selysub;
};


class basewin : public Window
{
public:
  basewin(int argc, char *argv[]);
  ~basewin();

  map<ident_t, sptr_sprite> sprite_map;
  map<ident_t, sptr_visor> visor_map;
      
  sptr_con_t mycon;
  client_t myclient;
  sptr_postman_t post;

  FileSelection *fs;
  dicewidget *dw;
  CList *cl;
  
  void file_okpressed();
  void file_cancelpressed();
  void quitslot();
  void menu_fileopen();
  void menu_helpabout();
  void resultavailable (client_t &, client_t::result &r);
  void disconnected(con_t &);
  void corruptreceived(postman_t &);
  virtual int delete_event_impl(GdkEventAny *event);

  void compsprite_create(sptr_compsprite &c, ident_t i);
  void visor_create(sptr_visor &v, ident_t id);
  void visor_adjust(sptr_visor &v, ident_t id);
  
  void selection_made(gint row, gint column, GdkEvent *event);
  void findvisor (const int32 cx, const int32 cy, ident_t &id);
};


// ----- implementation of dicewidget
dicewidget::dicewidget (basewin *const bw_)
  : bw(bw_), selid(0)
{
  set_events (get_events() | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK | GDK_POINTER_MOTION_MASK);
};

gint dicewidget::configure_event_impl (GdkEventConfigure *)
{
  cout << "config dicewidg" << width() << "\n";
  return true;
};

struct depth_sort {
  depth_sort (dicewidget &dw_) : dw(dw_) {};
  dicewidget &dw;
  int operator () (const ident_t &a, const ident_t &b) 
  {
    return dw.bw->visor_map[a]->depth < dw.bw->visor_map[b]->depth;
  };
};
    
gint dicewidget::expose_event_impl (GdkEventExpose *event)
{
  cout << "expose dicewidg\n";

  vector<ident_t> vec;

  map<ident_t, sptr_visor>::iterator mi;
  for (mi=bw->visor_map.begin();mi!=bw->visor_map.end();++mi) vec.push_back(mi->first);
  stable_sort(vec.begin(),vec.end(),depth_sort(*this));
  
  tempmatrix<rgba> back(width(),height());
  rgba nothing;
  nothing[0]=0;
  nothing[1]=0;
  nothing[2]=100;
  nothing[3]=255;
  back.fill(nothing);
  
  vector<ident_t>::iterator vi;
  for (vi=vec.begin();vi!=vec.end();++vi) {
    puttempmat(bw->visor_map[*vi]->x, bw->visor_map[*vi]->y,
	       bw->sprite_map[bw->visor_map[*vi]->picid]->rgbamap, back, false);
    
    //  drawsprite(*this,i->second->x,i->second->y,bw->sprite_map[i->second->picid]->rgbamap);    
  };
  
  drawsprite(*this,0,0,back);
  
  return false;
};

gint dicewidget::button_press_event_impl (GdkEventButton *event)
{
  if (event->button == 1) {
    cout << "button_press\n";
    bw->findvisor (event->x, event->y, selid);
    if (selid!=0) {
      selxsub=int32(event->x)-bw->visor_map[selid]->x;
      selysub=int32(event->y)-bw->visor_map[selid]->y;
    };
  } else if (event->button == 2) {
    bw->findvisor (event->x, event->y, selid);
    if (selid!=0) {
      sptr_visor &v (bw->visor_map[selid]);
      v->depth--;
      cout << "lowered visor with id " << selid << " to depth " << v->depth << "\n";
      bw->post->sender2<sptr_visor &, ident_t> ('e') (v, selid);
      queue_draw();
      selid=0;
    };
  } else if (event->button == 3) {
    bw->findvisor (event->x, event->y, selid);
    if (selid!=0) {
      sptr_visor &v (bw->visor_map[selid]);
      v->depth++;
      cout << "rised visor with id " << selid << " to depth " << v->depth << "\n";
      bw->post->sender2<sptr_visor &, ident_t> ('e') (v, selid);
      queue_draw();
      selid=0;
    };
  };
  return true;
}

gint dicewidget::button_release_event_impl (GdkEventButton *event)
{
  if (event->button == 1) {
    cout << "button_release\n";
    selid=0;
  };
  return true;
};

gint dicewidget::motion_notify_event_impl (GdkEventMotion *event)
{
  if (event->state & GDK_BUTTON1_MASK) {
    cout << "motion_notify\n";
    if (selid!=0) {
      sptr_visor &v (bw->visor_map[selid]);
      v->x=int32(event->x)-selxsub;
      v->y=int32(event->y)-selysub;
      bw->post->sender2<sptr_visor &, ident_t> ('e') (v, selid);
      queue_draw();
    };
  };
  return true;
};


// ----- implementation of basewin
basewin::basewin(int argc, char *argv[])
{
  fs =new FileSelection;
  fs->get_ok_button()->clicked.connect(slot(*this,&basewin::file_okpressed));
  fs->get_cancel_button()->clicked.connect(slot(*this,&basewin::file_cancelpressed));
  
  MenuBar *menubar = manage(new MenuBar());
  {
    using namespace Menu_Helpers;

    Menu *menu_file = manage (new Menu());
    MenuList &list_file = menu_file->items();

    list_file.push_back(MenuElem("_Open"));
    list_file.back()->activate.connect(slot(*this,&basewin::menu_fileopen));

    list_file.push_back(SeparatorElem());

    list_file.push_back(MenuElem("E_xit"));
    list_file.back()->activate.connect(slot(*this,&basewin::quitslot));

    Menu *menu_help = manage (new Menu());
    MenuList &list_help = menu_help->items();
    
    list_help.push_back(MenuElem("_About"));
    list_help.back()->activate.connect(slot(*this,&basewin::menu_helpabout));

    MenuList &list_bar = menubar->items();
    list_bar.push_front(MenuElem("_File",CTL | 'f',*menu_file));
    list_bar.push_back(MenuElem("_Help",CTL | 'h',*menu_help));
    list_bar.back()->right_justify();
  };

  VBox *vbox = manage (new VBox());
  vbox->pack_start(*menubar,false,false);
  
  HPaned *hpaned;
  {
    hpaned = manage (new HPaned());
    hpaned->set_handle_size (10);
    hpaned->set_gutter_size (15);                       
   
    dw = manage (new dicewidget(this));
    dw->size(400,400);
    hpaned->add1(*dw);

    static const gchar *titles[] = { "ID", "Name", 0 };
    cl = manage (new CList(titles));
    cl->select_row.connect(slot(*this,&basewin::selection_made));
    cl->set_usize(200,10);
    hpaned->add2(*cl);
  }
  vbox->pack_end(*hpaned);
  
  add (*vbox);
  set_title("dicetalk");
  //  set_default_size(400,200);

  show_all();

  if (argc!=2) fatal("please pass IP address, not hostname !!! as first and only parameter");
  
  myclient.netconnect(ipv4address(argv[1]),portnumber(10002)).
  connect(SigC::slot(*this,&basewin::resultavailable));
};

basewin::~basewin()
{
  post.kill();
  delete fs;
};

void basewin::file_okpressed()
{
  cout << "chosen " << fs->get_filename() << "\n";

  sptr_binbuff b(new binbuff());
  loadbinbuff(*b,fs->get_filename());
  post->sender2<sptr_binbuff &, const string &> ('a') (b, fs->get_filename());

/* GdkRectangle ur;
   ur.x=0;
   ur.y=0;
   ur.width=dw->width();
   ur.height=dw->height();
   dw->draw(&ur); */
};

void basewin::file_cancelpressed()
{
  fs->hide();
};

void basewin::quitslot()
{
  Main::quit();
};

void basewin::menu_fileopen()
{
  fs->show();
};

void basewin::menu_helpabout()
{
  // ever declared a string THIS ugly ???? hehe. i didn'T know
  // this was even possible until reading the gphoto source code...
  error_dialog("
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

See http://www.gnu.org for more details on the GNU project.

---------

open arbitrary image files with file open.
click on images in the list to create a visor for them.
move the visors with the left mousebutton.
lower a visor with the middle mousebutton.
raise a visor with the right mousebutton.
see on console for actual depth output..
"); 
};

void basewin::resultavailable (client_t &, client_t::result &r)
{
  if (r.isconnected()) {
    cout << "connected\n";
    mycon=r.getconnection();
    mycon->sig_disconnected.connect(SigC::slot(*this,&basewin::disconnected));
    post=new postman_t(&(*mycon));
    post->corruptreceived.connect(SigC::slot(*this,&basewin::corruptreceived));
    post->sender2_open<sptr_binbuff &, const string &> ('a');
    post->receiver2_open<sptr_compsprite &, ident_t> ('b')
      .connect(slot(*this,&basewin::compsprite_create));
    post->sender1_open<sptr_visor &> ('c');
    post->receiver2_open<sptr_visor &, ident_t> ('d')
      .connect(slot(*this,&basewin::visor_create));
    post->sender2_open<sptr_visor &, ident_t> ('e');
    post->receiver2_open<sptr_visor &, ident_t> ('e')
      .connect(slot(*this,&basewin::visor_adjust));
  }else{
    cout << "connection refused\n";
    Main::quit();
  };
};

void basewin::disconnected(con_t &)
{
  cout << "connection disconnected\n";
  Main::quit();
};

void basewin::corruptreceived(postman_t &)
{
  cout << "postman corruptreceived\n";
  mycon->disconnect();
};

int basewin::delete_event_impl(GdkEventAny *event)
{
  Main::quit();
  return true;
};

void basewin::compsprite_create(sptr_compsprite &c, ident_t i)
{
  cout << "compsprite_create\n";
  sptr_sprite s(new sprite(c));
  sprite_map[i]=s;
  vector<string> v;

  strstream oo;
  oo<<i;
  string si;
  oo>>si;
  
  //char oo[100];
  //sprintf(oo,"%lld",i);
  v.push_back(si);
  v.push_back(c->name);
  cl->rows().push_back(v);
};

void basewin::visor_create(sptr_visor &v, ident_t id)
{
  cout << "visor_create\n";
  visor_map[id]=v;

  dw->queue_draw();
};

void basewin::visor_adjust(sptr_visor &v, ident_t id)
{
  cout << "visor adjust\n";

  if (visor_map.find(id)==visor_map.end()) return;
  visor_map[id]=v;

  dw->queue_draw();
};

void basewin::selection_made(gint row, gint column, GdkEvent *event)
{
  ident_t id;
  strstream ss;
  
  ss << cl->cell(row,0).get_text();
  ss >> id;
  
  cout << "you clicked on id " << id << endl;
  
  sptr_visor v(new visor());
  v->x=10;
  v->y=20;
  v->picid=id;
  v->depth=0;
  
  post->sender1<sptr_visor &> ('c') (v);
};

void basewin::findvisor (const int32 cx, const int32 cy, ident_t &id)
{
  map<ident_t, sptr_visor>::iterator i;
  id=0;
  for (i=visor_map.begin();i!=visor_map.end();++i) {
    visor &v = *i->second;
    sprite &s = *sprite_map[v.picid];
    if ( (cx>=v.x) && (cy>=v.y) && (cx<v.x+s.rgbamap.xsize()) && (cy<v.y+s.rgbamap.ysize()) ) {
      if ( (id==0) || (visor_map[id]->depth <= i->second->depth) )
	id = i->first;
    };
  };
};


// ----- implementation of main program
int main (int argc, char *argv[])
{
  memchk::resetsituation(); // gtkmm disables my memchk. email is on way. let's see if they change it.
  {
    yyyexceptions::except_init();
    try {
      scheduler s;
      scheduler::gsched = &s;
      
      {
	Main myapp(argc, argv);

	gdk_rgb_init();
	gtk_widget_set_default_colormap (gdk_rgb_get_cmap());
	gtk_widget_set_default_visual (gdk_rgb_get_visual());
	
	basewin b(argc,argv);
	myapp.run();
      };
      
    } catch (yyyexceptions::except_base &x) {
      fatal(x.humandump());
    } catch (const char *const x) {
      fatal(x);
    } catch (...) {
      fatal("unspecified (...) exception caught.");
    };
  };
  if (!memchk::everythingzero()) memchk::printstatistics(cout);

  return 0;
};
