#ifndef __SENDSMARTPTR_HPP
#define __SENDSMARTPTR_HPP

#include "yyybinbuff.hpp"
#include "yyysmartptr.hpp"
#include "yyysendables.hpp"

template<class X>
void appendtobinbuffer (const yyysmartptr::smartptr<X> &a, yyybinbuff::binbuff &b)
{
  const bool isnull (a.isnull());
  appendtobinbuffer(isnull, b);
  if (!isnull) appendtobinbuffer(*a, b);
};

template<class X>
const yyybinbuff::binbuff::index
readfrombinbuffer(yyysmartptr::smartptr<X> &a, const yyybinbuff::binbuff &b,
		  const yyybinbuff::binbuff::index pos)
{
  yyybinbuff::binbuff::index read, mypos=pos;

  bool isnull;
  read=readfrombinbuffer(isnull,b,mypos);
  if (read<0) return read;
  mypos+=read;

  if (isnull) {
    a.kill();
  } else {
    if (a.isnull()) a=yyysmartptr::smartptr<X>(new X());
    read=readfrombinbuffer(*a,b,mypos);
    if (read<0) return read;
    mypos+=read;
  };
  
  return mypos-pos;
};

#endif
